<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.9.1"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>Lifinity Dungeon: cpp_filrouge_iscj_allemann/include/Room/Room.hpp Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">Lifinity Dungeon
   &#160;<span id="projectnumber">6</span>
   </div>
   <div id="projectbrief">The Lifinity Dungeon is a dungeon with an infinity of room. After each room, you found a harder room. This is why you will pass the eternity of your life in this dungeon</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.9.1 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Search','.html');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="dir_7b4dd9274471389300495e9c763ca813.html">cpp_filrouge_iscj_allemann</a></li><li class="navelem"><a class="el" href="dir_e5b3fe71963387781ba01d2a56ee1874.html">include</a></li><li class="navelem"><a class="el" href="dir_5c5cd00e5682e63edab20d6456cf76ed.html">Room</a></li>  </ul>
</div>
</div><!-- top -->
<div class="header">
  <div class="headertitle">
<div class="title">Room.hpp</div>  </div>
</div><!--header-->
<div class="contents">
<a href="_room_8hpp.html">Go to the documentation of this file.</a><div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno">    1</span>&#160; </div>
<div class="line"><a name="l00019"></a><span class="lineno">   19</span>&#160;<span class="preprocessor">#pragma once</span></div>
<div class="line"><a name="l00020"></a><span class="lineno">   20</span>&#160; </div>
<div class="line"><a name="l00021"></a><span class="lineno">   21</span>&#160;<span class="preprocessor">#include &lt;iostream&gt;</span></div>
<div class="line"><a name="l00022"></a><span class="lineno">   22</span>&#160;<span class="preprocessor">#include &lt;memory&gt;</span></div>
<div class="line"><a name="l00023"></a><span class="lineno">   23</span>&#160;<span class="preprocessor">#include &lt;vector&gt;</span></div>
<div class="line"><a name="l00024"></a><span class="lineno">   24</span>&#160;<span class="preprocessor">#include &quot;<a class="code" href="_lane_8hpp.html">.\Lane.hpp</a>&quot;</span></div>
<div class="line"><a name="l00025"></a><span class="lineno">   25</span>&#160;<span class="preprocessor">#include &quot;..\Enums.hpp&quot;</span></div>
<div class="line"><a name="l00026"></a><span class="lineno">   26</span>&#160;<span class="preprocessor">#include &quot;..\Character\CharacterClass.hpp&quot;</span></div>
<div class="line"><a name="l00027"></a><span class="lineno">   27</span>&#160; </div>
<div class="line"><a name="l00028"></a><span class="lineno">   28</span>&#160;<span class="keyword">using namespace </span>std;</div>
<div class="line"><a name="l00029"></a><span class="lineno">   29</span>&#160; </div>
<div class="line"><a name="l00030"></a><span class="lineno">   30</span>&#160;<span class="keyword">namespace </span>He_Arc::RPG</div>
<div class="line"><a name="l00031"></a><span class="lineno">   31</span>&#160;{</div>
<div class="line"><a name="l00038"></a><span class="lineno"><a class="line" href="class_he___arc_1_1_r_p_g_1_1_room.html">   38</a></span>&#160;    <span class="keyword">class </span><a class="code" href="class_he___arc_1_1_r_p_g_1_1_room.html">Room</a></div>
<div class="line"><a name="l00039"></a><span class="lineno">   39</span>&#160;    {</div>
<div class="line"><a name="l00040"></a><span class="lineno">   40</span>&#160;    <span class="keyword">public</span>:</div>
<div class="line"><a name="l00044"></a><span class="lineno"><a class="line" href="class_he___arc_1_1_r_p_g_1_1_room.html#a10fefae9f3e36dd00f073a576f77492b">   44</a></span>&#160;        <span class="keyword">const</span> <span class="keywordtype">int</span> FIRST_FIGHT_LANE = 1;</div>
<div class="line"><a name="l00049"></a><span class="lineno"><a class="line" href="class_he___arc_1_1_r_p_g_1_1_room.html#a8264718242a33b73a4ebc3520d1e56ee">   49</a></span>&#160;        <span class="keyword">const</span> <span class="keywordtype">int</span> ROOM_FIGHT_LANE_SIZE = 6;</div>
<div class="line"><a name="l00050"></a><span class="lineno">   50</span>&#160; </div>
<div class="line"><a name="l00055"></a><span class="lineno"><a class="line" href="class_he___arc_1_1_r_p_g_1_1_room.html#a5c84031f662272268c909354147d1555">   55</a></span>&#160;        <span class="keyword">enum</span> <a class="code" href="class_he___arc_1_1_r_p_g_1_1_room.html#a5c84031f662272268c909354147d1555">LaneName</a></div>
<div class="line"><a name="l00056"></a><span class="lineno">   56</span>&#160;        {</div>
<div class="line"><a name="l00057"></a><span class="lineno">   57</span>&#160;            BackLaneLeftSide = 1,</div>
<div class="line"><a name="l00058"></a><span class="lineno">   58</span>&#160;            MidLaneLeftSide,</div>
<div class="line"><a name="l00059"></a><span class="lineno">   59</span>&#160;            FrontLaneLeftSide,</div>
<div class="line"><a name="l00060"></a><span class="lineno">   60</span>&#160;            FrontLaneRightSide,</div>
<div class="line"><a name="l00061"></a><span class="lineno">   61</span>&#160;            MidLaneRightSide,</div>
<div class="line"><a name="l00062"></a><span class="lineno">   62</span>&#160;            BackLaneRightSide,</div>
<div class="line"><a name="l00063"></a><span class="lineno">   63</span>&#160;            DeadRightSide = -1, <span class="comment">// ally team dead characters</span></div>
<div class="line"><a name="l00064"></a><span class="lineno">   64</span>&#160;            DeadLeftSide = -2,  <span class="comment">// enemy team dead characters</span></div>
<div class="line"><a name="l00065"></a><span class="lineno">   65</span>&#160;            None = -3           <span class="comment">// Not on a lane (default, no utility now)</span></div>
<div class="line"><a name="l00066"></a><span class="lineno">   66</span>&#160;        };</div>
<div class="line"><a name="l00067"></a><span class="lineno">   67</span>&#160; </div>
<div class="line"><a name="l00068"></a><span class="lineno">   68</span>&#160;    <span class="keyword">private</span>:</div>
<div class="line"><a name="l00073"></a><span class="lineno">   73</span>&#160;        vector&lt;shared_ptr&lt;Lane&gt;&gt; m_fightLanes;</div>
<div class="line"><a name="l00078"></a><span class="lineno">   78</span>&#160;        vector&lt;shared_ptr&lt;Lane&gt;&gt; m_deadLanes;</div>
<div class="line"><a name="l00084"></a><span class="lineno">   84</span>&#160;        shared_ptr&lt;Lane&gt; m_backLaneLeftSide = make_shared&lt;Lane&gt;(<a class="code" href="class_he___arc_1_1_r_p_g_1_1_lane.html">Lane</a>{<span class="stringliteral">&quot;Back, left side&quot;</span>});</div>
<div class="line"><a name="l00089"></a><span class="lineno">   89</span>&#160;        shared_ptr&lt;Lane&gt; m_midLaneLeftSide = make_shared&lt;Lane&gt;(Lane{<span class="stringliteral">&quot;Mid, left side&quot;</span>});</div>
<div class="line"><a name="l00095"></a><span class="lineno">   95</span>&#160;        shared_ptr&lt;Lane&gt; m_frontLaneLeftSide = make_shared&lt;Lane&gt;(Lane{<span class="stringliteral">&quot;Front, left side&quot;</span>});</div>
<div class="line"><a name="l00100"></a><span class="lineno">  100</span>&#160;        shared_ptr&lt;Lane&gt; m_frontLaneRightSide = make_shared&lt;Lane&gt;(Lane{<span class="stringliteral">&quot;Front, Right side&quot;</span>});</div>
<div class="line"><a name="l00105"></a><span class="lineno">  105</span>&#160;        shared_ptr&lt;Lane&gt; m_midLaneRightSide = make_shared&lt;Lane&gt;(Lane{<span class="stringliteral">&quot;Mid, Right side&quot;</span>});</div>
<div class="line"><a name="l00110"></a><span class="lineno">  110</span>&#160;        shared_ptr&lt;Lane&gt; m_backLaneRightSide = make_shared&lt;Lane&gt;(Lane{<span class="stringliteral">&quot;Back, Right side&quot;</span>});</div>
<div class="line"><a name="l00115"></a><span class="lineno">  115</span>&#160;        shared_ptr&lt;Lane&gt; m_deadLaneLeftSide = make_shared&lt;Lane&gt;(Lane{<span class="stringliteral">&quot;Ally team dead characters&quot;</span>});</div>
<div class="line"><a name="l00120"></a><span class="lineno">  120</span>&#160;        shared_ptr&lt;Lane&gt; m_deadLaneRightSide = make_shared&lt;Lane&gt;(Lane{<span class="stringliteral">&quot;Enemy team dead characters&quot;</span>});</div>
<div class="line"><a name="l00121"></a><span class="lineno">  121</span>&#160; </div>
<div class="line"><a name="l00126"></a><span class="lineno">  126</span>&#160;        vector&lt;shared_ptr&lt;CharacterClass&gt;&gt; m_team1;</div>
<div class="line"><a name="l00131"></a><span class="lineno">  131</span>&#160;        vector&lt;shared_ptr&lt;CharacterClass&gt;&gt; m_team2;</div>
<div class="line"><a name="l00132"></a><span class="lineno">  132</span>&#160; </div>
<div class="line"><a name="l00138"></a><span class="lineno">  138</span>&#160;        vector&lt;shared_ptr&lt;Lane&gt;&gt; GetAllLanes() <span class="keyword">const</span>;</div>
<div class="line"><a name="l00139"></a><span class="lineno">  139</span>&#160; </div>
<div class="line"><a name="l00144"></a><span class="lineno">  144</span>&#160;        <span class="keywordtype">void</span> RandomPlaceCharactersOnLanes();</div>
<div class="line"><a name="l00145"></a><span class="lineno">  145</span>&#160; </div>
<div class="line"><a name="l00154"></a><span class="lineno">  154</span>&#160;        <span class="keywordtype">bool</span> IsFightMoveAllowed(shared_ptr&lt;CharacterClass&gt; character, <span class="keywordtype">int</span> dest);</div>
<div class="line"><a name="l00162"></a><span class="lineno">  162</span>&#160;        <span class="keywordtype">bool</span> IsFightLane(<span class="keyword">const</span> LaneName lane) <span class="keyword">const</span>;</div>
<div class="line"><a name="l00171"></a><span class="lineno">  171</span>&#160;        <span class="keywordtype">bool</span> IsFightLane(<span class="keyword">const</span> <span class="keywordtype">int</span> lane) <span class="keyword">const</span>;</div>
<div class="line"><a name="l00172"></a><span class="lineno">  172</span>&#160; </div>
<div class="line"><a name="l00173"></a><span class="lineno">  173</span>&#160;    <span class="keyword">public</span>:</div>
<div class="line"><a name="l00180"></a><span class="lineno">  180</span>&#160;        Room(vector&lt;shared_ptr&lt;CharacterClass&gt;&gt; team1, vector&lt;shared_ptr&lt;CharacterClass&gt;&gt; team2);</div>
<div class="line"><a name="l00181"></a><span class="lineno">  181</span>&#160;        <span class="keyword">virtual</span> ~Room() = <span class="keywordflow">default</span>;</div>
<div class="line"><a name="l00190"></a><span class="lineno">  190</span>&#160;        <span class="keywordtype">bool</span> IsFightMoveAllowed(shared_ptr&lt;CharacterClass&gt; character, LaneName dest);</div>
<div class="line"><a name="l00199"></a><span class="lineno">  199</span>&#160;        <span class="keywordtype">bool</span> IsMoveAllowed(shared_ptr&lt;CharacterClass&gt; character, LaneName dest);</div>
<div class="line"><a name="l00209"></a><span class="lineno">  209</span>&#160;        <span class="keywordtype">bool</span> MoveCharacterOneLane(shared_ptr&lt;CharacterClass&gt; character, <span class="keywordtype">bool</span> isRightMove);</div>
<div class="line"><a name="l00219"></a><span class="lineno">  219</span>&#160;        <span class="keywordtype">bool</span> MoveCharacterToLane(shared_ptr&lt;CharacterClass&gt; character, LaneName destination);</div>
<div class="line"><a name="l00225"></a><span class="lineno">  225</span>&#160;        <span class="keywordtype">void</span> MoveToDeadLane(shared_ptr&lt;CharacterClass&gt; character);</div>
<div class="line"><a name="l00232"></a><span class="lineno">  232</span>&#160;        LaneName GetLaneOfCharacter(<span class="keyword">const</span> shared_ptr&lt;CharacterClass&gt; &amp;character);</div>
<div class="line"><a name="l00242"></a><span class="lineno">  242</span>&#160;        vector&lt;shared_ptr&lt;CharacterClass&gt;&gt; GetCharactersOnLane(<span class="keyword">const</span> LaneName laneName, <span class="keywordtype">bool</span> onlyFightLane, TeamGrp specifiedTeam = TeamGrp::None);</div>
<div class="line"><a name="l00254"></a><span class="lineno">  254</span>&#160;        vector&lt;shared_ptr&lt;CharacterClass&gt;&gt; GetNeighbourCharacters(<span class="keyword">const</span> shared_ptr&lt;CharacterClass&gt; source, <span class="keywordtype">int</span> direction, TeamGrp specifiedTeam = TeamGrp::None);</div>
<div class="line"><a name="l00261"></a><span class="lineno">  261</span>&#160;        <a class="code" href="_enums_8hpp.html#ad46aac46ff35875d2e579285bc6289b9">TeamGrp</a> GetTeamOfCharacter(<span class="keyword">const</span> shared_ptr&lt;CharacterClass&gt; &amp;character);</div>
<div class="line"><a name="l00262"></a><span class="lineno">  262</span>&#160; </div>
<div class="line"><a name="l00267"></a><span class="lineno">  267</span>&#160;        <span class="keywordtype">void</span> ShowRoomInfo() <span class="keyword">const</span>;</div>
<div class="line"><a name="l00268"></a><span class="lineno">  268</span>&#160; </div>
<div class="line"><a name="l00273"></a><span class="lineno">  273</span>&#160;        <span class="keywordtype">void</span> DisplayRoom() <span class="keyword">const</span>;</div>
<div class="line"><a name="l00274"></a><span class="lineno">  274</span>&#160; </div>
<div class="line"><a name="l00279"></a><span class="lineno"><a class="line" href="class_he___arc_1_1_r_p_g_1_1_room.html#ac9f35a204bf0f8f3d99888a8051df286">  279</a></span>&#160;        map&lt;LaneName, shared_ptr&lt;Lane&gt;&gt; LaneNameToLane = {</div>
<div class="line"><a name="l00280"></a><span class="lineno">  280</span>&#160;            {LaneName::BackLaneLeftSide, m_backLaneLeftSide},</div>
<div class="line"><a name="l00281"></a><span class="lineno">  281</span>&#160;            {LaneName::MidLaneLeftSide, m_midLaneLeftSide},</div>
<div class="line"><a name="l00282"></a><span class="lineno">  282</span>&#160;            {LaneName::FrontLaneLeftSide, m_frontLaneLeftSide},</div>
<div class="line"><a name="l00283"></a><span class="lineno">  283</span>&#160;            {LaneName::FrontLaneRightSide, m_frontLaneRightSide},</div>
<div class="line"><a name="l00284"></a><span class="lineno">  284</span>&#160;            {LaneName::MidLaneRightSide, m_midLaneRightSide},</div>
<div class="line"><a name="l00285"></a><span class="lineno">  285</span>&#160;            {LaneName::BackLaneRightSide, m_backLaneRightSide},</div>
<div class="line"><a name="l00286"></a><span class="lineno">  286</span>&#160;            {LaneName::DeadLeftSide, m_deadLaneLeftSide},</div>
<div class="line"><a name="l00287"></a><span class="lineno">  287</span>&#160;            {LaneName::DeadRightSide, m_deadLaneRightSide},</div>
<div class="line"><a name="l00288"></a><span class="lineno">  288</span>&#160;            {LaneName::None, <span class="keyword">nullptr</span>}};</div>
<div class="line"><a name="l00289"></a><span class="lineno">  289</span>&#160; </div>
<div class="line"><a name="l00294"></a><span class="lineno"><a class="line" href="class_he___arc_1_1_r_p_g_1_1_room.html#ade1fe7f58277a6df414c3d6bf6e09319">  294</a></span>&#160;        map&lt;shared_ptr&lt;Lane&gt;, <a class="code" href="class_he___arc_1_1_r_p_g_1_1_room.html#a5c84031f662272268c909354147d1555">LaneName</a>&gt; LaneToLaneName = {</div>
<div class="line"><a name="l00295"></a><span class="lineno">  295</span>&#160;            {m_backLaneLeftSide, LaneName::BackLaneLeftSide},</div>
<div class="line"><a name="l00296"></a><span class="lineno">  296</span>&#160;            {m_midLaneLeftSide, LaneName::MidLaneLeftSide},</div>
<div class="line"><a name="l00297"></a><span class="lineno">  297</span>&#160;            {m_frontLaneLeftSide, LaneName::FrontLaneLeftSide},</div>
<div class="line"><a name="l00298"></a><span class="lineno">  298</span>&#160;            {m_frontLaneRightSide, LaneName::FrontLaneRightSide},</div>
<div class="line"><a name="l00299"></a><span class="lineno">  299</span>&#160;            {m_midLaneRightSide, LaneName::MidLaneRightSide},</div>
<div class="line"><a name="l00300"></a><span class="lineno">  300</span>&#160;            {m_backLaneRightSide, LaneName::BackLaneRightSide},</div>
<div class="line"><a name="l00301"></a><span class="lineno">  301</span>&#160;            {m_deadLaneLeftSide, LaneName::DeadLeftSide},</div>
<div class="line"><a name="l00302"></a><span class="lineno">  302</span>&#160;            {m_deadLaneRightSide, LaneName::DeadRightSide},</div>
<div class="line"><a name="l00303"></a><span class="lineno">  303</span>&#160;            {<span class="keyword">nullptr</span>, LaneName::None}};</div>
<div class="line"><a name="l00304"></a><span class="lineno">  304</span>&#160;    };</div>
<div class="line"><a name="l00305"></a><span class="lineno">  305</span>&#160; </div>
<div class="line"><a name="l00306"></a><span class="lineno">  306</span>&#160;} <span class="comment">// namespace He_Arc::RPG</span></div>
<div class="line"><a name="l00307"></a><span class="lineno">  307</span>&#160; </div>
<div class="line"><a name="l00308"></a><span class="lineno">  308</span>&#160;<span class="comment">/* OLD CODE</span></div>
<div class="line"><a name="l00309"></a><span class="lineno">  309</span>&#160;<span class="comment"></span> </div>
<div class="line"><a name="l00310"></a><span class="lineno">  310</span>&#160;<span class="comment">        /-**</span></div>
<div class="line"><a name="l00311"></a><span class="lineno">  311</span>&#160;<span class="comment">         * @brief Linking between a team and the TeamGrp</span></div>
<div class="line"><a name="l00312"></a><span class="lineno">  312</span>&#160;<span class="comment">         *</span></div>
<div class="line"><a name="l00313"></a><span class="lineno">  313</span>&#160;<span class="comment">         *-/</span></div>
<div class="line"><a name="l00314"></a><span class="lineno">  314</span>&#160;<span class="comment">        map&lt;vector&lt;shared_ptr&lt;CharacterClass&gt;&gt; , TeamGrp&gt; m_teamGrp = {</span></div>
<div class="line"><a name="l00315"></a><span class="lineno">  315</span>&#160;<span class="comment">            {m_team1, TeamGrp::Team1},</span></div>
<div class="line"><a name="l00316"></a><span class="lineno">  316</span>&#160;<span class="comment">            {m_team2, TeamGrp::Team2}};</span></div>
<div class="line"><a name="l00317"></a><span class="lineno">  317</span>&#160;<span class="comment"></span> </div>
<div class="line"><a name="l00318"></a><span class="lineno">  318</span>&#160;<span class="comment">        /-**</span></div>
<div class="line"><a name="l00319"></a><span class="lineno">  319</span>&#160;<span class="comment">         * @brief Get the lane corresponding to the linked enum</span></div>
<div class="line"><a name="l00320"></a><span class="lineno">  320</span>&#160;<span class="comment">         * </span></div>
<div class="line"><a name="l00321"></a><span class="lineno">  321</span>&#160;<span class="comment">         * @param lane lane name to get</span></div>
<div class="line"><a name="l00322"></a><span class="lineno">  322</span>&#160;<span class="comment">         * @return shared_ptr&lt;Lane&gt; corresponding lane</span></div>
<div class="line"><a name="l00323"></a><span class="lineno">  323</span>&#160;<span class="comment">         *-/</span></div>
<div class="line"><a name="l00324"></a><span class="lineno">  324</span>&#160;<span class="comment">        shared_ptr&lt;Lane&gt; GetLane(const LaneName lane);</span></div>
<div class="line"><a name="l00325"></a><span class="lineno">  325</span>&#160;<span class="comment"></span> </div>
<div class="line"><a name="l00326"></a><span class="lineno">  326</span>&#160;<span class="comment">        /-**</span></div>
<div class="line"><a name="l00327"></a><span class="lineno">  327</span>&#160;<span class="comment">         * @brief Get the LaneName value corresponding to the linked variable</span></div>
<div class="line"><a name="l00328"></a><span class="lineno">  328</span>&#160;<span class="comment">         * </span></div>
<div class="line"><a name="l00329"></a><span class="lineno">  329</span>&#160;<span class="comment">         * @param lane variable of the lane</span></div>
<div class="line"><a name="l00330"></a><span class="lineno">  330</span>&#160;<span class="comment">         * @return LaneName LaneName corresponding</span></div>
<div class="line"><a name="l00331"></a><span class="lineno">  331</span>&#160;<span class="comment">         *-/</span></div>
<div class="line"><a name="l00332"></a><span class="lineno">  332</span>&#160;<span class="comment">        LaneName GetLaneName(const shared_ptr&lt;Lane&gt; lane) const;</span></div>
<div class="line"><a name="l00333"></a><span class="lineno">  333</span>&#160;<span class="comment"></span> </div>
<div class="line"><a name="l00334"></a><span class="lineno">  334</span>&#160;<span class="comment">*/</span></div>
<div class="ttc" id="a_enums_8hpp_html_ad46aac46ff35875d2e579285bc6289b9"><div class="ttname"><a href="_enums_8hpp.html#ad46aac46ff35875d2e579285bc6289b9">He_Arc::RPG::TeamGrp</a></div><div class="ttdeci">TeamGrp</div><div class="ttdoc">The type of groups of characters.</div><div class="ttdef"><b>Definition:</b> Enums.hpp:32</div></div>
<div class="ttc" id="a_lane_8hpp_html"><div class="ttname"><a href="_lane_8hpp.html">Lane.hpp</a></div><div class="ttdoc">: Header file, for the class &quot;Lane.cpp&quot;</div></div>
<div class="ttc" id="aclass_he___arc_1_1_r_p_g_1_1_lane_html"><div class="ttname"><a href="class_he___arc_1_1_r_p_g_1_1_lane.html">He_Arc::RPG::Lane</a></div><div class="ttdoc">A lane is a part of a room, one lane have 0-N characters on it. It can be compared to the &quot;cell&quot; of t...</div><div class="ttdef"><b>Definition:</b> Lane.hpp:40</div></div>
<div class="ttc" id="aclass_he___arc_1_1_r_p_g_1_1_room_html"><div class="ttname"><a href="class_he___arc_1_1_r_p_g_1_1_room.html">He_Arc::RPG::Room</a></div><div class="ttdoc">The room is where the characters can do a fight. It contains lanes, and handle the laning (move chara...</div><div class="ttdef"><b>Definition:</b> Room.hpp:39</div></div>
<div class="ttc" id="aclass_he___arc_1_1_r_p_g_1_1_room_html_a5c84031f662272268c909354147d1555"><div class="ttname"><a href="class_he___arc_1_1_r_p_g_1_1_room.html#a5c84031f662272268c909354147d1555">He_Arc::RPG::Room::LaneName</a></div><div class="ttdeci">LaneName</div><div class="ttdoc">The name of each possible lane in the room.</div><div class="ttdef"><b>Definition:</b> Room.hpp:56</div></div>
</div><!-- fragment --></div><!-- contents -->
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated by&#160;<a href="https://www.doxygen.org/index.html"><img class="footer" src="doxygen.svg" width="104" height="31" alt="doxygen"/></a> 1.9.1
</small></address>
</body>
</html>
